!
! File is Parameter_control.f90
!
!   This file accepts inputs from the KernelInterface to alter parameters.  It also
! initializes some parameters.
!
! created on 04.25.11
!
! david arthur sampson
! last write was: 02.13.12
! ----------------------------------------------------------------------------------------
!
!       UNIT inputs
!
!      open(2,FILE=trim(trim(lvc_outputPath)//'Two.txt'), status='replace')
!      open(3,FILE=trim(trim(lvc_outputPath)//'Three.txt'), status='replace')
!      open(4,FILE=trim(trim(lvc_outputPath)//'Provider.txt'), status='replace')
!      open(5,FILE=trim(trim(lvc_outputPath)//'NormalFlow.txt'), status='replace')
!      open(7,FILE=trim(trim(lvc_outputPath)//'Log.txt'), status='replace')
!      open(8,FILE=trim(trim(lvc_outputPath)//'ProviderInputs.txt'), status='replace')
!      open(9,FILE=trim(trim(lvc_outputPath)//'MaricopaInputs.txt'), status='replace')

!       WaterShed_CO.f90
!      open(10,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_CObase.txt'),status='old')
!      open(11,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_COrunoff.txt'),status='unknown')
!      open(12,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_paleo.txt'),status='unknown')
!      open(13,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\CORiver_scenario.txt'),status='unknown')

!       WaterShed_SVT.f90
!      open(15,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\BofR_SVTbase.txt'),status='unknown')
!      open(16,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_BofR.txt'),status='unknown')
!      open(17,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_paleo.txt'),status='unknown')
!      open(18,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVTRivers_scenario.txt'),status='unknown')
!      open(19,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\SVT_doy.txt'),status="old")


!      open(22,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\powellequalizations.txt'),status='unknown')
!      open(23,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Initial_storage.txt'),status='unknown')

!       Groundwater.f90
!      open(24,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\cagrd.txt'),status='unknown')

!       WaterDemand_county.f90
!      open(26,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\populationGRmaricopa.txt'),status='unknown')
!      open(27,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\residentialdemand.txt'),status='old')
!      open(28,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\commandotherdemand.txt'),status='old')

!       WaterShed_CO.f90
!      open(30,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_CO.dat'),status='unknown')

!       WaterShed_SVT.f90
!      open(31,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_SVT.dat'),status='old')

!       WaterDemand_county.f90
!      open(32,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_D.dat'),status='old')

!       Groundwater.f90
!      open(33,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\GWdesignations.txt'),status='unknown')
!      open(34,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_GW.dat'),status='unknown')

!       Designations_CO.f90
!      open(35,FILE=trim(trim(lvc_dataPath)//"App_Data\Parameters\parm_PV.dat"))
!      open(36,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SurfaceWaterDesignations.txt'))

!
!       Designations_SVT.f90
!      open(40,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVTrott_new.txt'),status='unknown')
!      open(41,FILE=trim(trim(lvc_dataPath) &
!            //'App_Data\Parameters\SVthresholddesignations.txt'),status='unknown')
!      open(42,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVTacreage.txt'),status='unknown')

!       Designations_CO.f90
!      open(43,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\CAPdesignations.txt'),status='unknown')

!       Designations_SVT.f90
!      open(44,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\providerRightsTrott.txt'),status='unknown')
!      open(45,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Designations_Daily.txt'),status='unknown')
!      open(46,FILE=trim(trim(lvc_dataPath) &
!            //'App_Data\Parameters\SVT_Threshold_Daily.txt'),status='unknown')
!
!       ProviderPopulationandDemand.f90
!      open(50,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Population_2100.txt'),status="unknown")
!      open(51,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerdemandwithag.txt'),status="unknown")
!      open(52,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerArea_2006.txt'),status="unknown")
!      open(53,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\onProject_2030.txt'),status="unknown")
!
!       Meteorology.f90
!      open(60,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataBaseline.txt'),status='old')
!      open(61,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataProjected.txt'),status='old')
!
!       Water_CityModel.f90
!      open(65,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\Ag.txt'),status='old')
!      open(66,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\NaturalRecharge.txt'),status='old')
!
!       Kernel.f90
!      open(100,FILE=trim(trim(lvc_outputPath)//'onehundred.out'),status="replace")
!      open(101,FILE=trim(trim(lvc_outputPath)//'onehundredone.out'),status="replace")
!      open(102,FILE=trim(trim(lvc_outputPath)//'onehundredtwo.out'),status="replace")
!      open(103,FILE=trim(trim(lvc_outputPath)//'onehundredthree.out'),status="replace")
!      open(104,FILE=trim(trim(lvc_outputPath)//'onehundredfour.txt'),status="replace")
!      open(105,FILE=trim(trim(lvc_outputPath)//'onehundredfive.txt'),status="replace")
!      open(106,FILE=trim(trim(lvc_outputPath)//'onehundredsix.txt'),status="replace")
!      open(107,FILE=trim(trim(lvc_outputPath)//'onehundredseven.txt'),status="replace")

! =========================
Module lm_ParameterControl
  use gm_ModelControl
  use gm_GlobalParms
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
 contains
    ! ------------------------
    !  First subroutine called after: 1)connection to the model (i.e., build), 
    ! and 2) open files
    ! ---------------------------
    subroutine initParameters()
      integer :: i
        !
        call sMaskSRP(gvl_maskSRP)
        lvi_countSRP=1
      do i = 1,gvi_Providers,1
        if(.not. gpl_release)then
            !
            call Debug(i,lvi_countSRP)
            ! default settings for the model
            ! --------------------------------
            ! -------------------
            call Global(i)
            call General(i)
            call SVT(i,lvi_countSRP)
            call CO(i)
            call PopAndDemand(i)
!            call City(i)
            ! -------------------

            !
        else
            !
            ! default settings for the model
            ! --------------------------------
            ! -------------------
            call Global(i)
            call General(i)
            call SVT(i,lvi_countSRP)
            call CO(i)
            call PopAndDemand(i)
            call City(i)
            ! -------------------
        endif
      end do
    !
  end subroutine initParameters
  ! --------------------------

  ! --------------------------
    subroutine Global(i)
        integer :: i
        !
            gvi_startSimulationYear=2000
            gvi_endSimulationYear=2085      
            gvi_kernel_case=1
            gv_simyear=0
            gvl_Interrupt = .false.
        !
    end subroutine Global
    subroutine CO(i)
        integer :: i
        !
        gv_indexyearCO=1981
        gv_droughtyearCO=2001
        gv_droughtfactorCO=1.
        gv_droughtyearendCO=2026
        gv_climatefactorCO=1.
        !
    end subroutine CO
    subroutine SVT(i,lvi_countSRP)
        integer :: i,lvi_countSRP
        !
        gv_indexyearSVT=1981
        gv_droughtyearSVT=2001
        gv_climatefactorSVT=1.
        gv_droughtyearendSVT=2026
        gv_droughtfactorSVT=1.
            !
            gvf_modifyNormalFlow=2.0
        !
            if(gvl_maskSRP(i))then
                go_classBCdesignations(lvi_countSRP)=0

              lvi_countSRP=lvi_countSRP+1
            endif
        lid_dailyDesignationsSVT=0
    end subroutine SVT
    subroutine PopAndDemand(i)
        integer :: i
        !
             gvl_IncludeMeteorology=.false.
             goi_SES_GPCD(i)=0
             gvl_popFromInterface(i)=.false.
        !
    end subroutine PopAndDemand
    subroutine City(i)
        integer :: i
        !
             gvf_parm_WWtoIndReuse(i)=0.
             !
             gdf_parm_minGWtoGWT(i)=0.0
             gdf_parm_maxGWtoGWT(i)=1.0

             gvf_parm_WStoDI(i)=0.0
             gvl_parm_toiletPct=.false.
             gvf_parm_BWpctRes(i)=0. 
             gvl_parm_grayWater=.true.
        !
            ! No provider (22) and other provider (23)
                !
                gvf_reclaimedOutput(2000,22,1)=0
                gvf_reclaimedOutput(2000,23,1)=0
                gvf_ROreclaimedOutput(2000,22,1)=0
                gvf_ROreclaimedOutput(2000,23,1)=0
                !
                gvf_reclaimedInput(2000,22,1)=0
                gvf_reclaimedInput(2000,23,1)=0
                gvf_ROreclaimedInput(2000,22,1)=0
                gvf_ROreclaimedInput(2000,23,1)=0
                !
        !
    end subroutine City
    subroutine General(i)
        integer :: i,j
        !
             go_ProviderGroundWater_a(i)=0
              gvi_WaterFromAgPumping_AF_a(i)=0
               do j = 1,3
                 gvf_designationsCAPandSRP(i,j)=0.
               end do
            go_GWPumpageMuni_acft(i)=0
            go_GWRecharge_acft(i)=0
            go_ProviderWaterUsed_acft(i)=0
        !
    end subroutine General
    subroutine Debug(i,lvi_countSRP)
        integer :: i,lvi_countSRP

          gvl_IncludeMeteorology=.false.
            ! Done
            gvf_parm_RtoVadose(i)=0.1
            ! Done
            gvf_parm_RtoDInjection(i)=0.1

            ! Done
            gvf_parm_RtoOutput(i)=0.5
            gvf_parm_RtoOutput(i)=0.0

            ! --------------------------------------
            ! Done
            gvf_parm_WWtoRWWTP(i)=1.0
            ! Done
            gvf_parm_RWWtoRO(i)=1.0
            ! Done
            gvf_parm_ROtoOutput(i)=0.5
            gvf_parm_ROtoOutput(i)=0.0

            ! Newest
            gvf_parm_RtoInputMaxPct(i)=0.1
            ! Done
            gvf_parm_OutDoorProp(i)=0.5 ! 0.7059592774019
            ! Done
            gvf_parm_ReclaimedOutdoor(i)=1.0
            ! Done
            gvf_parm_WStoRes_Prop(i)=0.7
            ! Done
            gvf_parm_WStoCio_Prop(i)=0.3
            ! Done
            gvf_parm_WStoDI(i)=0.0
            !
            ! For now this will remain = 1 (i.e., no surface discharge)

            ! Done    
            gvf_parm_WWtoEffluent(i)=1-0.1-gvf_parm_WWtoRWWTP(i)
            ! For now, this will remain zero with NO interface connection
            gvf_parm_WWtoIndReuse(i)=0.0
            ! Done
            gvf_parm_SWtoVadose(i)=0.0
            ! Done
            gvf_parm_SWtoWB(i)=0.0
    !        gdf_parm_maxSWtoWB(i)=0.2
    !        gdf_parm_minSWtoWB(i)=0
!            gdf_parm_maxSWtoV(i)=0.16
!            gdf_parm_minSWtoV(i)=0

            ! temporary
            gvf_parm_EffluentToPP(33)=0.1
            gvf_parm_EffluentToPP(25)=0.0
            gvf_parm_EffluentToPP(30)=0.0
            gvf_parm_EffluentToPP(32)=0
            gvf_parm_EffluentToPP(1)=0
            ! Done
            gvf_parm_EffluentToVadose(i)=0.2
            ! Done
            gvf_parm_GWtoGWTP(i)=0.0
            gdf_parm_minGWtoGWT(i)=0.0
            gdf_parm_maxGWtoGWT(i)=1.0
            !
!            if(gvl_maskSRP(i))then
!              gvf_modifyNormalFlow(lvi_countSRP)=2.0 ! acre-feet per acre of normal flow
!              lvi_countSRP=lvi_countSRP+1
!            endif
    end subroutine Debug
  ! ---------------------------
End module lm_ParameterControl

Module lms_ParameterControl
  use gm_ModelControl
  use gm_GlobalParms
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
 contains
  subroutine initGlobalParms()
    integer :: i
    !
      do i = 1,gvi_Providers,1
        !
        gdf_parm_minGWtoGWT(i)=0.0
        gdf_parm_maxGWtoGWT(i)=1.0
        !
      end do
    !
  end subroutine initGlobalParms
  ! ----------------------------

  ! -----------------------------
  subroutine modifyDesignations()
        integer :: i,j
        real :: lvf_normalFlow(10)
        real :: fModifyNormalFlow
            !
            lvf_normalFlow=gvf_modifyNormalFlow
            !
             if(gvl_start)then
               do i = 1,42,1
                  do j = 1,10,1
                    ! alter the acre-feet per acre designated [comes in from the interface]
                    ! see notes (BuildNotes) 01.18.12 DAS
                     lid_dailyDesignationsSVT(i,j)=fModifyNormalFlow(lvf_normalFlow(j))* lid_dailyDesignationsSVT(i,j)
                  end do
                end do
            endif
      return
    end subroutine modifyDesignations
    ! -------------------------------
 !
End Module lms_ParameterControl
!
! =================================================================================================
!
 ! -------------------------------
 subroutine sCityParameterControl_a(T)
  use gm_Global
   use lms_ParameterControl
      !
      integer :: i
 
      type(runTime)T
      ! =============
        !
        if(T%startyear < T%year)then

          do i = 1,gvi_Providers,1
            if(.not. gvl_parm_shortage(i))then   
              gvf_hold_WStoDI(i)=gvf_parm_WStoDI(i)
              gvf_hold_RtoDInjection(i)=gvf_parm_RtoDInjection(i)
              gvf_hold_ROtoOutput(i)=gvf_parm_ROtoOutput(i)
              gvf_hold_RtoOutput(i)=gvf_parm_RtoOutput(i)
              gvf_hold_RtoVadose(i)=gvf_parm_RtoVadose(i)
            endif
          end do
        else
           if(gvl_WriteToDisk)write(7,*)"  sCityParameterControl_a"
        !
         call initGlobalParms()
         call sInputsCity(T)
         call modifyDesignations()
        !
          do i = 1,gvi_Providers,1
            gvf_hold_WStoDI(i)=gvf_parm_WStoDI(i)
            gvf_hold_RtoDInjection(i)=gvf_parm_RtoDInjection(i)
            gvf_hold_ROtoOutput(i)=gvf_parm_ROtoOutput(i)
            gvf_hold_RtoOutput(i)=gvf_parm_RtoOutput(i)
            gvf_hold_RtoVadose(i)=gvf_parm_RtoVadose(i)
          end do
        endif
       return
        !
 end subroutine sCityParameterControl_a
 ! --------------------------------

 ! -------------------------------------
 subroutine sParameterControl_tstep(T,i)
  use gm_Global
   use lms_ParameterControl
      !
      integer :: i

      type(runTime)T
      ! ===============
          if(gvl_parm_shortage(i))then        
            gvf_parm_WStoDI(i)=0.0
            gvf_parm_RtoDInjection(i)=0.0  
            gvf_parm_RWWtoRO(i)=0.0
            gvf_parm_RtoVadose(i)=0.0
          else
            gvf_parm_WStoDI(i)= gvf_hold_WStoDI(i)
            gvf_parm_RtoDInjection(i)=gvf_hold_RtoDInjection(i)
            gvf_parm_ROtoOutput(i)=gvf_hold_ROtoOutput(i)
            gvf_parm_RtoOutput(i)=gvf_hold_RtoOutput(i)
            gvf_parm_RtoVadose(i)=gvf_hold_RtoVadose(i)
          endif
        return
       !
 end subroutine sParameterControl_tstep
 ! ------------------------------------

 ! ------------------------
 subroutine ClearInclude(T)
  use gm_Global
   use lms_ParameterControl
     !
     !--- TYPE constructs ---
     type(runTime)T
     ! ============
      !
        gvf_AG_Banking(T%year)=0
      !
 end subroutine ClearInclude
 ! -------------------------



        !
        ! -----------------------
        subroutine sInputsCity(T)
          use gm_ModelControl
           use lms_ParameterControl

           integer :: i
  
            type(runTime)T
           ! ===============
            ! Called once
            do i = 1,gvi_Providers,1
              gvf_WBankingBalance(T%year,i,1)=0.
              if(1 < gvi_WBankingOption(i))then
                gvf_WBankingBalance(T%year,i,1)=gvf_parm_SWtoWBamount(i)
              endif
            end do
            !
              if(.not. gpl_release)then
                do i = 1,gvi_Providers,1
                 gvi_WBankingOption(i)=2
                  gvf_parm_SWtoVadoseAmt(i)=0
                  gvf_parm_WStoDIamount(i)=0
                end do
              endif
            !
            ! These will be annual amounts.  Must be defined in the interface
            do i = 1,gvi_Providers,1
              if(0 < gvf_parm_WWtoRWWTP(i))then
                if(0 <  gvf_parm_RtoOutput(i))then
                   if(2000 < T%year)then
                     gvf_reclaimedInput(T%year-1,i,1) =0
                    gvf_reclaimedInput(T%year-1,i,1) = &
                      (gvf_WaterDemand_AF(i,1,1)*(1-gvf_parm_OutDoorProp(i)) &
                      * gvf_parm_RtoOutput(i)*(1-gvf_parm_RWWtoRO(i))*gvf_parm_WWtoRWWTP(i) &
                      * gvf_parm_RtoInputMaxPct(i) ) * 10 
                    !
                    gvf_reclaimedOutput(T%year-1,i,1) =gvf_reclaimedInput(T%year-1,i,1)
                    !
                   else
                    gvf_reclaimedInput(T%year,i,1) = &
                      (gvf_WaterDemand_AF(i,1,1)*(1-gvf_parm_OutDoorProp(i)) &
                      * gvf_parm_RtoOutput(i)*(1-gvf_parm_RWWtoRO(i))*gvf_parm_WWtoRWWTP(i) &
                      * gvf_parm_RtoInputMaxPct(i) ) * 10
                    ! 03.05.12 DAS
                    gvf_reclaimedOutput(T%year,i,1) =gvf_reclaimedInput(T%year,i,1)
                   endif
                else
                    if(2000 < T%year)gvf_reclaimedInput(T%year-1,i,1)  =0
                     gvf_reclaimedInput(T%year,i,1)    =0
                    if(2000 < T%year)gvf_reclaimedOutput(T%year-1,i,1) =0
                     gvf_reclaimedOutput(T%year,i,1)   =0
                endif
                if(0 <  gvf_parm_ROtoOutput(i))then
                  if(2000 < T%year)then
                     gvf_ROreclaimedInput(T%year,i,1)= &
                       gvf_WaterDemand_AF(i,1,1)* (1-gvf_parm_OutDoorProp(i)) &
                        *  gvf_parm_RWWtoRO(i)* gvf_parm_ROtoOutput(i)*gvf_parm_WWtoRWWTP(i)

                     gvf_ROreclaimedOutput(T%year-1,i,1) =gvf_ROreclaimedInput(T%year,i,1)
                  else
                    gvf_ROreclaimedInput(T%year,i,1)= &
                       gvf_WaterDemand_AF(i,1,1)* (1-gvf_parm_OutDoorProp(i)) &
                        *  gvf_parm_RWWtoRO(i)* gvf_parm_ROtoOutput(i)*gvf_parm_WWtoRWWTP(i)

                     gvf_ROreclaimedOutput(T%year,i,1) =gvf_ROreclaimedInput(T%year,i,1)
                  endif
                endif
              endif
            end do
            !
           !
        end subroutine sInputsCity
        ! ------------------------
! ========================================================================================================== 
! E.O.F