program Program
   use lm_BuildNotes
      use lm_Initialize
       use lm_Kernel
       !
       implicit none
       !
        integer :: i
       call startupK();
       call InitK()
        do i = 1,40,1
       call RunOneYearKernel()
        end do
       call teardownK()
       !
end program Program
!
! --------------------------------------------

! --------------------------------------------
!  subroutine tags()
!    integer :: a; data a /5000/
!    character(len=15) :: input
!    integer :: j,k,l,m,n,o,p
!    i = ibits(a,6,7)
!    j = ibits(a,5,7)
!    k = ibits(a,4,7)
!    l = ibits(a,3,7)
!    m = ibits(a,2,7)
!    n = ibits(a,1,7)
!    o = ibits(a,0,7 )
!
!    write(*,"(b34)") i,j,k,l,m,n,o
!    read(*,*) input
!  end subroutine tags
!
!module lms_WaterSimTest1
!! use iso_c_binding
! use gm_GlobalData
! use gm_Global
!    !
!    Include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
!    !
! contains
!  subroutine test1A(P)
!
!    type(providers) :: P
!    
!
!      P%ph%SVT_po%f_classA_maf_yr=0.1
!      P%te%SVT_po%f_classA_maf_yr=0.05
!      P%me%SVT_po%f_classA_maf_yr=0.01
!      P%to%SVT_po%f_classA_maf_yr=0.005
!      P%ch%SVT_po%f_classA_maf_yr=0.001
!
!    SVT_ro%gvi_state = 2000000
!    SVT_ro%gvi_release = 100000
!    SVT_ro%gvi_runoff = 300000
!
!!    write(7,*)"test1A",  P%ch%SVT_po%f_classA_maf_yr
!  
!  end subroutine test1A
! !
!end module lms_WaterSimTest1
!  !
!  !
!  subroutine test1()
!    use lms_WaterSimTest1
!     type(providers)::P
!     !
!     call test1A(P)
!     call returnType(P)
!     !
!  end subroutine test1
!!
! subroutine returnType(R)
!   use lms_WaterSimTest1    
!    type(SVTonto_r)::R
!  R%gvi_release=1 
! end subroutine returnType
! =================================================================================================
! E.O.F.